import { Assets, Ticker } from 'pixi.js';
import ReelsMachine from 'src/slotMachines/ReelsMachine';
import { createScreenInputMap } from 'src/stories/utils/createScreenInputMap';
import MachineContainer from 'src/stories/utils/MachineContainer';
import { centerView } from 'src/stories/utils/resize';
import GridSystem from 'src/systems/GridSystem';
import { SlotMachineConfig } from 'src/types/SlotMachineConfig';
import { Meta, PixiStory, StoryFn } from '@pixi/storybook-renderer';
import MockSystem from "src/systems/MockSystem";

const args = {

};

const meta: Meta<typeof GridSystem> = {
    title: 'Systems/InitSystem', // Путь для отображения в Storybook
    tags: ['autodocs'], // Включает автоматическую генерацию документации
    parameters: {
        docs: {
            story: {
                height: 600
            },
            description: {
                component: 'A system responsible for initializing symbols in the slot machine. It only runs once, adding symbols based on `initMap` data to the main scene and marking initialization as complete.'
            },
        }
    },
};

export default meta;

export const GridSystemStory: StoryFn<typeof args> = (_params, context) => new PixiStory({
    context, init: async (view) =>
    {
        Assets.reset();
        await Assets.init({
            manifest: 'area69/manifest.json',
        });
        await Assets.loadBundle('configs');
        await Assets.loadBundle('symbols');
        const config: SlotMachineConfig = Assets.get('slot_machine_config');
        const machine = new ReelsMachine(config);
        const container = new MachineContainer(machine);
        machine.systems.blockExitState = new MockSystem(machine)
        view.addChild(container);
        context.machine = machine;
        machine.inputs.initMap = createScreenInputMap(config);
        machine.systems.idle.setSettings(_params);
        centerView(view);
    },
    resize: centerView,
    update: () =>
    {
        context.machine && context.machine.update(Ticker.shared.deltaMS);
        context.machine.systems.idle.setSettings(_params);
    }
});
